#!/usr/bin/env ruby
$LOAD_PATH.unshift("#{File.dirname(__FILE__)}/")
require 'game_tile'
require 'minesweeper_game'
require 'game_board'
require 'minesweeper_parser'

puts "Welcome to the game of minesweeper!"

# Make the parser for parsing the data
begin
  options = MinesweeperParser.new.parse(ARGV)
rescue OptionParser::MissingArgument, OptionParser::InvalidArgument
  help_msg = MinesweeperParser.new.parse(["-h"])
  puts help_msg
end

# Create the board. We can now use the arguments that have been handled by the arguments 
# parser class. The arguments have been stored in a hash in an OpenStruct object.
board = GameBoard.new(options.rows_cols_chance[:rows], options.rows_cols_chance[:cols], options.rows_cols_chance[:bomb_chance])


# Use the MinesweeperGame class to play the game
game = MinesweeperGame.new(board, options.rows_cols_chance[:rows], options.rows_cols_chance[:cols])

game.print_the_board
while !game.game_over? && !game.win? do
 game.play_the_game
end

if game.game_over?
  puts "\n Underlying board shown below\n"
  game.print_ending_board
  puts "Oops! You selected a bomb. Please play again!"
elsif game.win?
  puts "\n Underlying board shown below\n"
  game.print_ending_board
  puts "Congrats you won the game!"
end

